require 'sick'

gamestate = 'title'
lgni = love.graphics.newImage

function love.load()
	
	highscore.set('highscore.txt', 1)
	
	square = {
		pic = love.graphics.newImage('pics/square.png'),
		x = 900,
		y = 500,
		speed = 450,
		w = 80,
		h = 74
	}
	menu = {
		gameover = love.graphics.newImage('pics/menu/game_over.png'),
		title = love.graphics.newImage('pics/menu/title.png'),
		controls = lgni('pics/menu/controls.png'),
		credits = lgni('pics/menu/credits.png'),
	}
	triangle = {
		pic = love.graphics.newImage('pics/triangle.png'),
		x = 900,
		y = 50,
		speed = 500,
		w = 80,
		h = 61
		
	}
	circle = {
		pic = love.graphics.newImage('pics/circle.png'),
		x = 900,
		y = 200,
		speed = 350,
		w = 80,
		h = 72
	}
	player = {
		pic = love.graphics.newImage('pics/player.png'),
		x = 50,
		y = 300,
		speed = 350,
		w = 63,
		h = 69,
		score = 0,
		lev = 0,
	}
end
function love.draw()
	love.graphics.setBackgroundColor(145,200,255)
	if gamestate == 'game' then
		love.graphics.print('Score: '..player.score..' ',10,10)
		
		love.graphics.draw(square.pic, square.x, square.y)
		love.graphics.draw(circle.pic, circle.x, circle.y)
		love.graphics.draw(triangle.pic, triangle.x, triangle.y)
		
		love.graphics.draw(player.pic, player.x, player.y)
		
	elseif gamestate == 'title' then
		love.graphics.draw(menu.title,0,0)
		for i, score, name in highscore() do
			--love.graphics.print(name..' ', 400, i * 130)
			love.graphics.print('Highscore: ',400, 130)
			love.graphics.print(score, 470, 130)
		end
		
		
	elseif gamestate == 'gameover' then 
		love.graphics.draw(menu.gameover,0,0)
		love.graphics.print("Your Score is: "..player.score.."", 400,120)

		--love.graphics.draw(highscore(),400, 160)
	elseif gamestate == 'controls' then
		love.graphics.draw(menu.controls, 0, 0)
	
	elseif gamestate == 'credits' then
		love.graphics.draw(menu.credits, 0, 0)
	end
end
function love.update( dt )
	if gamestate == 'game' then
		square.x = square.x - square.speed * dt
		circle.x = circle.x - circle.speed * dt
		triangle.x = triangle.x - triangle.speed * dt
		
		if square.x < 0 then
			math.randomseed(os.time())
			randome = math.random(500, 600)
			
			square.x = 900
			square.y = randome
			square.speed = square.speed + 1
			
			if square.speed > 1000 * dt then 
				square.speed = 1000
			end 		
			player.score = player.score + 0.3
		elseif circle.x < 0 then
			math.randomseed(os.time())
			rando = math.random(200, 450)
			
			circle.x = 900
			circle.y = rando
			circle.speed = circle.speed + 1
			
			if circle.speed > 1000 * dt then 
				circle.speed = 1000
			end 		
			player.score = player.score + 0.3
		elseif triangle.x < 0 then
			math.randomseed(os.time())
			rand = math.random(100)
			
			triangle.x = 900
			triangle.y = rand
			triangle.speed = triangle.speed + 1
			
			
			if triangle.speed > 1000 * dt then 
				triangle.speed = 1000
			end 
			player.score = player.score + 0.4
			
		elseif player.y < 0 then
			player.y = 5
			player.speed = 0
		elseif player.y + player.h > 700 then
			player.y = player.y - 5
			player.speed = 0
		else
			player.speed = 350
		end
		if love.keyboard.isDown('up') or love.keyboard.isDown('w') then
			player.y = player.y - player.speed * dt
		elseif love.keyboard.isDown('down') or love.keyboard.isDown('s') then
			player.y = player.y + player.speed * dt		
		end
		
		if player.x + player.w > square.x and player.x + player.w < square.x + square.w and player.y + player.h > square.y and player.y + player.h < square.y + square.h then		
			gamestate = 'gameover'
		elseif player.x + player.w > circle.x and player.x + player.w < circle.x + circle.w and player.y + player.h > circle.y and player.y + player.h < circle.y + circle.h then	
			gamestate = 'gameover'
		elseif player.x + player.w > triangle.x and player.x + player.w < triangle.x + triangle.w and player.y + player.h > triangle.y and player.y + player.h < triangle.y + triangle.h then
			gamestate = 'gameover'
		end
	elseif gamestate == 'gameover' then
		highscore.add('Your Highscore is: ', player.score)		
		highscore.save()
		
	end
end
function love.keypressed( key )
	if gamestate == 'gameover' then
		if key == 'return' then
			square = {
				pic = love.graphics.newImage('pics/square.png'),
				x = 900,
				y = 500,
				speed = 450,
				w = 80,
				h = 74,
			}
			triangle = {
				pic = love.graphics.newImage('pics/triangle.png'),
				x = 900,
				y = 50,
				speed = 500,
				w = 80,
				h = 61,
			
			}
			circle = {
				pic = love.graphics.newImage('pics/circle.png'),
				x = 900,
				y = 200,
				speed = 350,
				w = 80,
				h = 72,
			}
			player = {
				pic = love.graphics.newImage('pics/player.png'),
				x = 50,
				y = 300,
				speed = 350,
				w = 63,
				h = 69,
				score = 0,
				level = 0,
			}
			gamestate = 'title'
		elseif key == 'q' then
			square = {
				pic = love.graphics.newImage('pics/square.png'),
				x = 900,
				y = 500,
				speed = 450,
				w = 80,
				h = 74
			}
			triangle = {
				pic = love.graphics.newImage('pics/triangle.png'),
				x = 900,
				y = 50,
				speed = 500,
				w = 80,
				h = 61
			
			}
			circle = {
				pic = love.graphics.newImage('pics/circle.png'),
				x = 900,
				y = 200,
				speed = 350,
				w = 80,
				h = 72
			}
			player = {
				pic = love.graphics.newImage('pics/player.png'),
				x = 50,
				y = 300,
				speed = 350,
				w = 63,
				h = 69,
				score = 0,
			}
			gamestate = 'game'	
		end
	elseif gamestate == 'title' then
		if key == 'return' then
			gamestate = 'game'
		elseif key == 'k' then
			gamestate = 'credits'
			
		elseif key == 'c' then
			gamestate = 'controls'
		end
	end
	if key == 'escape' then
		highscore.save()
		love.event.push('quit')
	elseif key == 'backspace' then
		gamestate = 'title'
		
			square = {
				pic = love.graphics.newImage('pics/square.png'),
				x = 900,
				y = 500,
				speed = 450,
				w = 80,
				h = 74
			}
			
			triangle = {
				pic = love.graphics.newImage('pics/triangle.png'),
				x = 900,
				y = 50,
				speed = 500,
				w = 80,
				h = 61
			
			}
			circle = {
				pic = love.graphics.newImage('pics/circle.png'),
				x = 900,
				y = 200,
				speed = 350,
				w = 80,
				h = 72
			}
			player = {
				pic = love.graphics.newImage('pics/player.png'),
				x = 50,
				y = 300,
				speed = 350,
				w = 63,
				h = 69,
				score = 0,
			}
	end
end
function love.quit()
		highscore.save()
  print("Thanks for playing! Come back soon!")
end